//Copyleft(2011)= Michael Margolis
//Modificat (2013): Alumnes ( M. Cots , H. Llorca i D. Pons).
//Revisat (2013): Carles Ferrando
// Ping))) Sensor que escolta l'eco dels ultrasons
// mesura la distància, emet un so depenent de la distancia,
// i escriu les dades en una pantalla LCD
//License: GNU GPL http://www.gnu.org/licenses/gpl.html
const int pingPin =10; 

const int altaveu = 8;

#include <LiquidCrystal.h>

LiquidCrystal lcd(12,11, 5, 4, 3, 2);

void setup()
{
 lcd.setCursor(0, 0);

// Posem el cursor a la columna 0, fila 0 (la primera fila):

//Serial.begin(9600); //definisc el monitor sèrie quan faig proves amb l'ordinador

}

void loop()

{

int cm = ping(pingPin) ;

Serial.print("Distancia en cm="); //Imprimesc el rètol

Serial.println(cm); //Imprimesc la distància
delay(cm * 10 ); // cada centímetre afegeix 10 milisegons de retard per mostrar més temps el missatge
if(cm >= 257){//inici while

lcd.begin(16, 2);

lcd.print("Distancia en cm="); //Imprimesc el rètol

lcd.setCursor(0, 1);

lcd.println(cm); //Imprimesc la distància

tone(altaveu,261, 333); // interpreta la nota Do usant la seua freqüència

delay(333);//fem un silenci de 333 ms

} 

if(cm>=214 and cm<257){

lcd.begin(16, 2);

lcd.print("Distancia en cm="); //Imprimesc el rètol

lcd.setCursor(0, 1);

lcd.println(cm); //Imprimesc la distància

tone(altaveu,294, 333); // interpreta la nota Re usant la seua freqüència

delay(333); //fem un silenci de 333 ms

}

if(cm>=171 and cm<214){

lcd.begin(16, 2);

lcd.print("Distancia en cm="); //Imprimesc el rètol

lcd.setCursor(0, 1);

lcd.println(cm); //Imprimesc la distància

tone(altaveu,329, 333); // interpreta la nota Mi usant la seua freqüència

delay(333); //fem un silenci de 333 ms

}
if(cm>=129 and cm<171){
lcd.begin(16, 2);
lcd.print("Distancia en cm="); //Imprimesc el rètol
lcd.setCursor(0, 1);
lcd.println(cm); //Imprimesc la distància
tone(altaveu,349, 333); // interpreta la nota Fa usant la seua freqüència
delay(333); //fem un silenci de 333 ms
}
if(cm>=86 and cm<129){

lcd.begin(16, 2);

lcd.print("Distancia en cm="); //Imprimesc el rètol

lcd.setCursor(0, 1);

lcd.println(cm); //Imprimesc la distància

tone(altaveu,392, 333); // interpreta la nota Sol usant la seua freqüència

delay(333); //fem un silenci de 333 ms
}

if(cm>=43 and cm<86){

lcd.begin(16, 2);

lcd.print("Distancia en cm="); //Imprimesc el rètol

lcd.setCursor(0, 1);

lcd.println(cm); //Imprimesc la distància

tone(altaveu,440, 333); // interpreta la nota La usant la seua freqüència

delay(333); //fem un silenci de 333 ms

}

if(cm<43){

lcd.begin(16, 2);

lcd.print("Distancia en cm="); //Imprimesc el rètol

lcd.setCursor(0, 1);

lcd.println(cm); //Imprimesc la distància

tone(altaveu,493, 333); // interpreta la nota Si usant la seua freqüència

delay(333); //fem un silenci de 4000 ms

}

}

//

// funció que calcula la distància en cm escoltant el eco del so emés

// basat en el codi de http://www.arduino.cc/en/Tutorial/Ping

int ping(int pingPin) // funció que retorna la distancia en cm

{

// establiment de les variables de la duració del pols de so

// i la distància calculada en centimetres

long duracio, cm;

// El eco PING))) és generat per un pols apagat de 2 o més microsegons.

// seguit dun pols engegat (així el pols és net) de 5 microsegons:

pinMode(pingPin, OUTPUT); //definim el sensor d'eixida

digitalWrite(pingPin, LOW); //fem un pols apagat de 2 microsegons

delayMicroseconds(2);

digitalWrite(pingPin, HIGH); //fem un pols engegat de 5 microsegons

delayMicroseconds(5);

digitalWrite(pingPin, LOW); //apaguen el pols 

pinMode(pingPin, INPUT); //definim el sensor d'entrada

duracio = pulseIn(pingPin, HIGH); //escoltem el sensor per oir l'eco

cm = microsegonsAcentimetres(duracio); //cridem la funció que convertirà el temps en centímetres

return cm ; //retorna la distància en cm al programa principal

}

//

//funció per convertir el temps de microsegons en centímetres

long microsegonsAcentimetres(long microsegons)

{

// La velocitat del so és de 340 m/s o de 29 microsegons per centímetre.

// El so s'emet i retorna en forma de eco , per això la distància a l'objecte

// és la meitat del temps total d'anada i tornada.

return microsegons / 29 / 2; // retorna el valor de la distància en microsegons

			}
